-- variables
BGDefender_VERSION = "1.5.1";

BGDefender_ShowUI = 0;

function BGDefender_OnLoad(self)
    self:RegisterEvent("ADDON_LOADED");
    self:RegisterEvent("VARIABLES_LOADED");
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
    out("BG Defender loaded (ver "..BGDefender_VERSION.."). Type /bgd help for options.");

    SLASH_BGDefender1 = "/BGDefender";
    SLASH_BGDefender2 = "/bgd";

    SlashCmdList["BGDefender"] = function(msg)
        BGDefender_SlashCommandHandler(msg);
    end
end

function BGDefender_SlashCommandHandler(msg)
    msg = strlower(msg);
    if (msg == "help") then
        DEFAULT_CHAT_FRAME:AddMessage("BG Defender Version "..BGDefender_VERSION, 1.0, 0.5, 0.0);
        DEFAULT_CHAT_FRAME:AddMessage("/bgd [show/hide] - show/hide window", 1.0, 0.5, 0.0);
        DEFAULT_CHAT_FRAME:AddMessage("/bgd status - BGDefender status", 1.0, 0.5, 0.0);
    elseif (msg == "show") then
        BGDefender_ShowUI = BGDefender_Toggle(1)
    elseif (msg == "hide") then
        BGDefender_ShowUI = BGDefender_Toggle(0)
    elseif (msg == "status") then
        BGDefender_ShowStatus();
    else
        BGDefender_ShowUI = BGDefender_Toggle();
    end
end

function BGDefender_OnEvent(frame, event, ...)
    if ((event == "ZONE_CHANGED_NEW_AREA") or (event == "ADDON_LOADED")) then
       if(BGDefender_isInBG()) then                      
           BGDefender_ShowUI = BGDefender_Toggle(1);
       elseif (BGDefender_ShowUI == 1) then
           BGDefender_ShowUI = BGDefender_Toggle(0);
       end
    elseif (event == "VARIABLES_LOADED") then
        if (not BGDefender_Vars_Loaded ) then
            BGDefender_Vars_Loaded = 1;
        end
    end
end

function out(text)
    if (text) then
        DEFAULT_CHAT_FRAME:AddMessage(text, 1, 0, 0)
        UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
	end
end

function BGDefender_close()
    BGDefender_ShowUI = BGDefender_Toggle(0)
end

-- sending the chat message
function BGDefender_NumCall(arg1)
    local location = nil; 
    local call = "";

    if (not BGDefender_isInBG()) then
        out(BGD_OUT);
        return;  
    end
    
    location = GetSubZoneText();
    
    if (location ~= "") then
        if(arg1==6) then
            call = BGD_INCPLUS;
        elseif(arg1==0) then
            call = BGD_SAFE;
        elseif(arg1==9) then
            call = BGD_HELP;
        else 
            call = BGD_INC;
            call = string.gsub(call, "$num", arg1);
        end
        call = string.gsub(call, "$base", location);
		if (BGDefender_isInRaidBG()) then
            SendChatMessage(call, "RAID");
		else
            SendChatMessage(call, "BATTLEGROUND");
		end
    else
        out(BGD_AWAY);
    end
end

function BGDefender_OnClick(arg1)
    id = this:GetID()
    out("BGDefender: OnClick: " .. this:GetName() .. " ,ID: " .. id .. " ,Button:" ..arg1)
end

function BGDefender_ShowStatus()
    DEFAULT_CHAT_FRAME:AddMessage("BG Defender Version "..BGDefender_VERSION.." Status", 1.0, 0.5, 0.0);
	if (BGDefender_ShowUI == 1) then
        DEFAULT_CHAT_FRAME:AddMessage("UI Visible: Yes", 1.0, 0.5, 0.0);
	else
        DEFAULT_CHAT_FRAME:AddMessage("UI Visible: Currently hidden.  Type /bgd to display.", 1.0, 0.5, 0.0);
	end
    DEFAULT_CHAT_FRAME:AddMessage("zone: "..GetZoneText().." ("..GetSubZoneText()..")", 1.0, 0.5, 0.0);
	if (BGDefender_isInBG()) then
        DEFAULT_CHAT_FRAME:AddMessage("In a BG zone? Yes", 1.0, 0.5, 0.0);
	else
        DEFAULT_CHAT_FRAME:AddMessage("In a BG zone? No", 1.0, 0.5, 0.0);
	end
end

-- show/hide window per chat command
function BGDefender_Toggle(num)
    local frame  = getglobal("RIC5");
    local status = nil; 
    if (frame) then
        if (num == 0) then
            frame:Hide();
            status = 0;
        elseif (num == 1) then
            frame:Show();
            status = 1;
        else    
            if(frame:IsVisible()) then
                frame:Hide();
                status = 0;
            else
                frame:Show();
                status = 1;
            end
        end
        return status;
    end
end

-- check if in those BGs that are really zones, like WG
function BGDefender_isInRaidBG()
    local zone = GetZoneText();
    local found = false;
	if ((zone == BGD_WG)) then
        found = true;
	end
    return found;
end

-- check if in any BG, including WG
function BGDefender_isInBG()
    local zone = GetZoneText();
    local found = false;
	if ((zone == BGD_AV) or (zone == BGD_AB) or (zone == BGD_WSG) or (zone == BGD_WSL) or (zone == BGD_SWH) or (zone == BGD_EOTS) or (zone == BGD_SOTA) or (zone == BGD_IOC)) then
        found = true;
	elseif (BGDefender_isInRaidBG()) then
	    found = true
	end
    return found;
end
